#include <linux/fb.h>


struct display {
	int cursor_x;							/* current cursor position */
	int cursor_y;
#if 0											/* no hardware cursor support yet */
	volatile u_short movecursor;		/* cursor move latch */
#endif
	u_short cursor_visible;

	int fgcol;								/* text colors */
	int bgcol;

	struct fb_var_screeninfo var;		/* variable infos */
	struct fb_cmap	cmap;					/* colormap */

	u_char *screen_base;					/* pointer to top of virtual screen */    
	int type;								/* see FB_TYPE_* */
	int type_aux;							/* Interleave for interleaved Planes */
	u_long ywrapstep;						/* zero if no hardware ywrap */

	u_char *fontdata;						/* Font associated to this display */
	int fontheight;
	int fontwidth;

	u_long next_line;						/* offset to one line below */
	u_long next_plane;					/* offset to next plane */

	struct display_switch *dispsw;	/* low level operations */
}; 


struct fb_info {
	char modename[40];					/* name of the at boottime detected video mode */
	struct display *disp;				/* pointer to display variables */
	int (*changevar)(int);				/* tell the console var has changed */
	int (*switch_con)(int);				/* tell the framebuffer to switch consoles */
	int (*updatevar)(int);				/* tell the framebuffer to update the vars */
	void (*blank)(int);					/* tell the framebuffer to (un)blank the screen */
};

struct fb_info *amifb_init(long *);
